package com.lightinit.hsdataplatform.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class RoadshowExample extends BaseExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public RoadshowExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andRoadshowStateIsNull() {
            addCriterion("roadshow_state is null");
            return (Criteria) this;
        }

        public Criteria andRoadshowStateIsNotNull() {
            addCriterion("roadshow_state is not null");
            return (Criteria) this;
        }

        public Criteria andRoadshowStateEqualTo(String value) {
            addCriterion("roadshow_state =", value, "roadshowState");
            return (Criteria) this;
        }

        public Criteria andRoadshowStateNotEqualTo(String value) {
            addCriterion("roadshow_state <>", value, "roadshowState");
            return (Criteria) this;
        }

        public Criteria andRoadshowStateGreaterThan(String value) {
            addCriterion("roadshow_state >", value, "roadshowState");
            return (Criteria) this;
        }

        public Criteria andRoadshowStateGreaterThanOrEqualTo(String value) {
            addCriterion("roadshow_state >=", value, "roadshowState");
            return (Criteria) this;
        }

        public Criteria andRoadshowStateLessThan(String value) {
            addCriterion("roadshow_state <", value, "roadshowState");
            return (Criteria) this;
        }

        public Criteria andRoadshowStateLessThanOrEqualTo(String value) {
            addCriterion("roadshow_state <=", value, "roadshowState");
            return (Criteria) this;
        }

        public Criteria andRoadshowStateLike(String value) {
            addCriterion("roadshow_state like", value, "roadshowState");
            return (Criteria) this;
        }

        public Criteria andRoadshowStateNotLike(String value) {
            addCriterion("roadshow_state not like", value, "roadshowState");
            return (Criteria) this;
        }

        public Criteria andRoadshowStateIn(List<String> values) {
            addCriterion("roadshow_state in", values, "roadshowState");
            return (Criteria) this;
        }

        public Criteria andRoadshowStateNotIn(List<String> values) {
            addCriterion("roadshow_state not in", values, "roadshowState");
            return (Criteria) this;
        }

        public Criteria andRoadshowStateBetween(String value1, String value2) {
            addCriterion("roadshow_state between", value1, value2, "roadshowState");
            return (Criteria) this;
        }

        public Criteria andRoadshowStateNotBetween(String value1, String value2) {
            addCriterion("roadshow_state not between", value1, value2, "roadshowState");
            return (Criteria) this;
        }

        public Criteria andRoadshowNameIsNull() {
            addCriterion("roadshow_name is null");
            return (Criteria) this;
        }

        public Criteria andRoadshowNameIsNotNull() {
            addCriterion("roadshow_name is not null");
            return (Criteria) this;
        }

        public Criteria andRoadshowNameEqualTo(String value) {
            addCriterion("roadshow_name =", value, "roadshowName");
            return (Criteria) this;
        }

        public Criteria andRoadshowNameNotEqualTo(String value) {
            addCriterion("roadshow_name <>", value, "roadshowName");
            return (Criteria) this;
        }

        public Criteria andRoadshowNameGreaterThan(String value) {
            addCriterion("roadshow_name >", value, "roadshowName");
            return (Criteria) this;
        }

        public Criteria andRoadshowNameGreaterThanOrEqualTo(String value) {
            addCriterion("roadshow_name >=", value, "roadshowName");
            return (Criteria) this;
        }

        public Criteria andRoadshowNameLessThan(String value) {
            addCriterion("roadshow_name <", value, "roadshowName");
            return (Criteria) this;
        }

        public Criteria andRoadshowNameLessThanOrEqualTo(String value) {
            addCriterion("roadshow_name <=", value, "roadshowName");
            return (Criteria) this;
        }

        public Criteria andRoadshowNameLike(String value) {
            addCriterion("roadshow_name like", value, "roadshowName");
            return (Criteria) this;
        }

        public Criteria andRoadshowNameNotLike(String value) {
            addCriterion("roadshow_name not like", value, "roadshowName");
            return (Criteria) this;
        }

        public Criteria andRoadshowNameIn(List<String> values) {
            addCriterion("roadshow_name in", values, "roadshowName");
            return (Criteria) this;
        }

        public Criteria andRoadshowNameNotIn(List<String> values) {
            addCriterion("roadshow_name not in", values, "roadshowName");
            return (Criteria) this;
        }

        public Criteria andRoadshowNameBetween(String value1, String value2) {
            addCriterion("roadshow_name between", value1, value2, "roadshowName");
            return (Criteria) this;
        }

        public Criteria andRoadshowNameNotBetween(String value1, String value2) {
            addCriterion("roadshow_name not between", value1, value2, "roadshowName");
            return (Criteria) this;
        }

        public Criteria andFinancingTypeIsNull() {
            addCriterion("financing_type is null");
            return (Criteria) this;
        }

        public Criteria andFinancingTypeIsNotNull() {
            addCriterion("financing_type is not null");
            return (Criteria) this;
        }

        public Criteria andFinancingTypeEqualTo(String value) {
            addCriterion("financing_type =", value, "financingType");
            return (Criteria) this;
        }

        public Criteria andFinancingTypeNotEqualTo(String value) {
            addCriterion("financing_type <>", value, "financingType");
            return (Criteria) this;
        }

        public Criteria andFinancingTypeGreaterThan(String value) {
            addCriterion("financing_type >", value, "financingType");
            return (Criteria) this;
        }

        public Criteria andFinancingTypeGreaterThanOrEqualTo(String value) {
            addCriterion("financing_type >=", value, "financingType");
            return (Criteria) this;
        }

        public Criteria andFinancingTypeLessThan(String value) {
            addCriterion("financing_type <", value, "financingType");
            return (Criteria) this;
        }

        public Criteria andFinancingTypeLessThanOrEqualTo(String value) {
            addCriterion("financing_type <=", value, "financingType");
            return (Criteria) this;
        }

        public Criteria andFinancingTypeLike(String value) {
            addCriterion("financing_type like", value, "financingType");
            return (Criteria) this;
        }

        public Criteria andFinancingTypeNotLike(String value) {
            addCriterion("financing_type not like", value, "financingType");
            return (Criteria) this;
        }

        public Criteria andFinancingTypeIn(List<String> values) {
            addCriterion("financing_type in", values, "financingType");
            return (Criteria) this;
        }

        public Criteria andFinancingTypeNotIn(List<String> values) {
            addCriterion("financing_type not in", values, "financingType");
            return (Criteria) this;
        }

        public Criteria andFinancingTypeBetween(String value1, String value2) {
            addCriterion("financing_type between", value1, value2, "financingType");
            return (Criteria) this;
        }

        public Criteria andFinancingTypeNotBetween(String value1, String value2) {
            addCriterion("financing_type not between", value1, value2, "financingType");
            return (Criteria) this;
        }

        public Criteria andFinancingAmountIsNull() {
            addCriterion("financing_amount is null");
            return (Criteria) this;
        }

        public Criteria andFinancingAmountIsNotNull() {
            addCriterion("financing_amount is not null");
            return (Criteria) this;
        }

        public Criteria andFinancingAmountEqualTo(BigDecimal value) {
            addCriterion("financing_amount =", value, "financingAmount");
            return (Criteria) this;
        }

        public Criteria andFinancingAmountNotEqualTo(BigDecimal value) {
            addCriterion("financing_amount <>", value, "financingAmount");
            return (Criteria) this;
        }

        public Criteria andFinancingAmountGreaterThan(BigDecimal value) {
            addCriterion("financing_amount >", value, "financingAmount");
            return (Criteria) this;
        }

        public Criteria andFinancingAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("financing_amount >=", value, "financingAmount");
            return (Criteria) this;
        }

        public Criteria andFinancingAmountLessThan(BigDecimal value) {
            addCriterion("financing_amount <", value, "financingAmount");
            return (Criteria) this;
        }

        public Criteria andFinancingAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("financing_amount <=", value, "financingAmount");
            return (Criteria) this;
        }

        public Criteria andFinancingAmountIn(List<BigDecimal> values) {
            addCriterion("financing_amount in", values, "financingAmount");
            return (Criteria) this;
        }

        public Criteria andFinancingAmountNotIn(List<BigDecimal> values) {
            addCriterion("financing_amount not in", values, "financingAmount");
            return (Criteria) this;
        }

        public Criteria andFinancingAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("financing_amount between", value1, value2, "financingAmount");
            return (Criteria) this;
        }

        public Criteria andFinancingAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("financing_amount not between", value1, value2, "financingAmount");
            return (Criteria) this;
        }

        public Criteria andProjectPhaseIsNull() {
            addCriterion("project_phase is null");
            return (Criteria) this;
        }

        public Criteria andProjectPhaseIsNotNull() {
            addCriterion("project_phase is not null");
            return (Criteria) this;
        }

        public Criteria andProjectPhaseEqualTo(String value) {
            addCriterion("project_phase =", value, "projectPhase");
            return (Criteria) this;
        }

        public Criteria andProjectPhaseNotEqualTo(String value) {
            addCriterion("project_phase <>", value, "projectPhase");
            return (Criteria) this;
        }

        public Criteria andProjectPhaseGreaterThan(String value) {
            addCriterion("project_phase >", value, "projectPhase");
            return (Criteria) this;
        }

        public Criteria andProjectPhaseGreaterThanOrEqualTo(String value) {
            addCriterion("project_phase >=", value, "projectPhase");
            return (Criteria) this;
        }

        public Criteria andProjectPhaseLessThan(String value) {
            addCriterion("project_phase <", value, "projectPhase");
            return (Criteria) this;
        }

        public Criteria andProjectPhaseLessThanOrEqualTo(String value) {
            addCriterion("project_phase <=", value, "projectPhase");
            return (Criteria) this;
        }

        public Criteria andProjectPhaseLike(String value) {
            addCriterion("project_phase like", value, "projectPhase");
            return (Criteria) this;
        }

        public Criteria andProjectPhaseNotLike(String value) {
            addCriterion("project_phase not like", value, "projectPhase");
            return (Criteria) this;
        }

        public Criteria andProjectPhaseIn(List<String> values) {
            addCriterion("project_phase in", values, "projectPhase");
            return (Criteria) this;
        }

        public Criteria andProjectPhaseNotIn(List<String> values) {
            addCriterion("project_phase not in", values, "projectPhase");
            return (Criteria) this;
        }

        public Criteria andProjectPhaseBetween(String value1, String value2) {
            addCriterion("project_phase between", value1, value2, "projectPhase");
            return (Criteria) this;
        }

        public Criteria andProjectPhaseNotBetween(String value1, String value2) {
            addCriterion("project_phase not between", value1, value2, "projectPhase");
            return (Criteria) this;
        }

        public Criteria andTradeFieldIsNull() {
            addCriterion("trade_field is null");
            return (Criteria) this;
        }

        public Criteria andTradeFieldIsNotNull() {
            addCriterion("trade_field is not null");
            return (Criteria) this;
        }

        public Criteria andTradeFieldEqualTo(String value) {
            addCriterion("trade_field =", value, "tradeField");
            return (Criteria) this;
        }

        public Criteria andTradeFieldNotEqualTo(String value) {
            addCriterion("trade_field <>", value, "tradeField");
            return (Criteria) this;
        }

        public Criteria andTradeFieldGreaterThan(String value) {
            addCriterion("trade_field >", value, "tradeField");
            return (Criteria) this;
        }

        public Criteria andTradeFieldGreaterThanOrEqualTo(String value) {
            addCriterion("trade_field >=", value, "tradeField");
            return (Criteria) this;
        }

        public Criteria andTradeFieldLessThan(String value) {
            addCriterion("trade_field <", value, "tradeField");
            return (Criteria) this;
        }

        public Criteria andTradeFieldLessThanOrEqualTo(String value) {
            addCriterion("trade_field <=", value, "tradeField");
            return (Criteria) this;
        }

        public Criteria andTradeFieldLike(String value) {
            addCriterion("trade_field like", value, "tradeField");
            return (Criteria) this;
        }

        public Criteria andTradeFieldNotLike(String value) {
            addCriterion("trade_field not like", value, "tradeField");
            return (Criteria) this;
        }

        public Criteria andTradeFieldIn(List<String> values) {
            addCriterion("trade_field in", values, "tradeField");
            return (Criteria) this;
        }

        public Criteria andTradeFieldNotIn(List<String> values) {
            addCriterion("trade_field not in", values, "tradeField");
            return (Criteria) this;
        }

        public Criteria andTradeFieldBetween(String value1, String value2) {
            addCriterion("trade_field between", value1, value2, "tradeField");
            return (Criteria) this;
        }

        public Criteria andTradeFieldNotBetween(String value1, String value2) {
            addCriterion("trade_field not between", value1, value2, "tradeField");
            return (Criteria) this;
        }

        public Criteria andRoadshowTagIsNull() {
            addCriterion("roadshow_tag is null");
            return (Criteria) this;
        }

        public Criteria andRoadshowTagIsNotNull() {
            addCriterion("roadshow_tag is not null");
            return (Criteria) this;
        }

        public Criteria andRoadshowTagEqualTo(String value) {
            addCriterion("roadshow_tag =", value, "roadshowTag");
            return (Criteria) this;
        }

        public Criteria andRoadshowTagNotEqualTo(String value) {
            addCriterion("roadshow_tag <>", value, "roadshowTag");
            return (Criteria) this;
        }

        public Criteria andRoadshowTagGreaterThan(String value) {
            addCriterion("roadshow_tag >", value, "roadshowTag");
            return (Criteria) this;
        }

        public Criteria andRoadshowTagGreaterThanOrEqualTo(String value) {
            addCriterion("roadshow_tag >=", value, "roadshowTag");
            return (Criteria) this;
        }

        public Criteria andRoadshowTagLessThan(String value) {
            addCriterion("roadshow_tag <", value, "roadshowTag");
            return (Criteria) this;
        }

        public Criteria andRoadshowTagLessThanOrEqualTo(String value) {
            addCriterion("roadshow_tag <=", value, "roadshowTag");
            return (Criteria) this;
        }

        public Criteria andRoadshowTagLike(String value) {
            addCriterion("roadshow_tag like", value, "roadshowTag");
            return (Criteria) this;
        }

        public Criteria andRoadshowTagNotLike(String value) {
            addCriterion("roadshow_tag not like", value, "roadshowTag");
            return (Criteria) this;
        }

        public Criteria andRoadshowTagIn(List<String> values) {
            addCriterion("roadshow_tag in", values, "roadshowTag");
            return (Criteria) this;
        }

        public Criteria andRoadshowTagNotIn(List<String> values) {
            addCriterion("roadshow_tag not in", values, "roadshowTag");
            return (Criteria) this;
        }

        public Criteria andRoadshowTagBetween(String value1, String value2) {
            addCriterion("roadshow_tag between", value1, value2, "roadshowTag");
            return (Criteria) this;
        }

        public Criteria andRoadshowTagNotBetween(String value1, String value2) {
            addCriterion("roadshow_tag not between", value1, value2, "roadshowTag");
            return (Criteria) this;
        }

        public Criteria andPublishByIsNull() {
            addCriterion("publish_by is null");
            return (Criteria) this;
        }

        public Criteria andPublishByIsNotNull() {
            addCriterion("publish_by is not null");
            return (Criteria) this;
        }

        public Criteria andPublishByEqualTo(Long value) {
            addCriterion("publish_by =", value, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByNotEqualTo(Long value) {
            addCriterion("publish_by <>", value, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByGreaterThan(Long value) {
            addCriterion("publish_by >", value, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByGreaterThanOrEqualTo(Long value) {
            addCriterion("publish_by >=", value, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByLessThan(Long value) {
            addCriterion("publish_by <", value, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByLessThanOrEqualTo(Long value) {
            addCriterion("publish_by <=", value, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByIn(List<Long> values) {
            addCriterion("publish_by in", values, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByNotIn(List<Long> values) {
            addCriterion("publish_by not in", values, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByBetween(Long value1, Long value2) {
            addCriterion("publish_by between", value1, value2, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishByNotBetween(Long value1, Long value2) {
            addCriterion("publish_by not between", value1, value2, "publishBy");
            return (Criteria) this;
        }

        public Criteria andPublishAtIsNull() {
            addCriterion("publish_at is null");
            return (Criteria) this;
        }

        public Criteria andPublishAtIsNotNull() {
            addCriterion("publish_at is not null");
            return (Criteria) this;
        }

        public Criteria andPublishAtEqualTo(Date value) {
            addCriterion("publish_at =", value, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtNotEqualTo(Date value) {
            addCriterion("publish_at <>", value, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtGreaterThan(Date value) {
            addCriterion("publish_at >", value, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtGreaterThanOrEqualTo(Date value) {
            addCriterion("publish_at >=", value, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtLessThan(Date value) {
            addCriterion("publish_at <", value, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtLessThanOrEqualTo(Date value) {
            addCriterion("publish_at <=", value, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtIn(List<Date> values) {
            addCriterion("publish_at in", values, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtNotIn(List<Date> values) {
            addCriterion("publish_at not in", values, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtBetween(Date value1, Date value2) {
            addCriterion("publish_at between", value1, value2, "publishAt");
            return (Criteria) this;
        }

        public Criteria andPublishAtNotBetween(Date value1, Date value2) {
            addCriterion("publish_at not between", value1, value2, "publishAt");
            return (Criteria) this;
        }

        public Criteria andAuditedByIsNull() {
            addCriterion("audited_by is null");
            return (Criteria) this;
        }

        public Criteria andAuditedByIsNotNull() {
            addCriterion("audited_by is not null");
            return (Criteria) this;
        }

        public Criteria andAuditedByEqualTo(Long value) {
            addCriterion("audited_by =", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByNotEqualTo(Long value) {
            addCriterion("audited_by <>", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByGreaterThan(Long value) {
            addCriterion("audited_by >", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByGreaterThanOrEqualTo(Long value) {
            addCriterion("audited_by >=", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByLessThan(Long value) {
            addCriterion("audited_by <", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByLessThanOrEqualTo(Long value) {
            addCriterion("audited_by <=", value, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByIn(List<Long> values) {
            addCriterion("audited_by in", values, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByNotIn(List<Long> values) {
            addCriterion("audited_by not in", values, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByBetween(Long value1, Long value2) {
            addCriterion("audited_by between", value1, value2, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedByNotBetween(Long value1, Long value2) {
            addCriterion("audited_by not between", value1, value2, "auditedBy");
            return (Criteria) this;
        }

        public Criteria andAuditedAtIsNull() {
            addCriterion("audited_at is null");
            return (Criteria) this;
        }

        public Criteria andAuditedAtIsNotNull() {
            addCriterion("audited_at is not null");
            return (Criteria) this;
        }

        public Criteria andAuditedAtEqualTo(Date value) {
            addCriterion("audited_at =", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtNotEqualTo(Date value) {
            addCriterion("audited_at <>", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtGreaterThan(Date value) {
            addCriterion("audited_at >", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("audited_at >=", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtLessThan(Date value) {
            addCriterion("audited_at <", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtLessThanOrEqualTo(Date value) {
            addCriterion("audited_at <=", value, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtIn(List<Date> values) {
            addCriterion("audited_at in", values, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtNotIn(List<Date> values) {
            addCriterion("audited_at not in", values, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtBetween(Date value1, Date value2) {
            addCriterion("audited_at between", value1, value2, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditedAtNotBetween(Date value1, Date value2) {
            addCriterion("audited_at not between", value1, value2, "auditedAt");
            return (Criteria) this;
        }

        public Criteria andAuditResultIsNull() {
            addCriterion("audit_result is null");
            return (Criteria) this;
        }

        public Criteria andAuditResultIsNotNull() {
            addCriterion("audit_result is not null");
            return (Criteria) this;
        }

        public Criteria andAuditResultEqualTo(String value) {
            addCriterion("audit_result =", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultNotEqualTo(String value) {
            addCriterion("audit_result <>", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultGreaterThan(String value) {
            addCriterion("audit_result >", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultGreaterThanOrEqualTo(String value) {
            addCriterion("audit_result >=", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultLessThan(String value) {
            addCriterion("audit_result <", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultLessThanOrEqualTo(String value) {
            addCriterion("audit_result <=", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultLike(String value) {
            addCriterion("audit_result like", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultNotLike(String value) {
            addCriterion("audit_result not like", value, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultIn(List<String> values) {
            addCriterion("audit_result in", values, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultNotIn(List<String> values) {
            addCriterion("audit_result not in", values, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultBetween(String value1, String value2) {
            addCriterion("audit_result between", value1, value2, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditResultNotBetween(String value1, String value2) {
            addCriterion("audit_result not between", value1, value2, "auditResult");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionIsNull() {
            addCriterion("audit_opinion is null");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionIsNotNull() {
            addCriterion("audit_opinion is not null");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionEqualTo(String value) {
            addCriterion("audit_opinion =", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionNotEqualTo(String value) {
            addCriterion("audit_opinion <>", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionGreaterThan(String value) {
            addCriterion("audit_opinion >", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionGreaterThanOrEqualTo(String value) {
            addCriterion("audit_opinion >=", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionLessThan(String value) {
            addCriterion("audit_opinion <", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionLessThanOrEqualTo(String value) {
            addCriterion("audit_opinion <=", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionLike(String value) {
            addCriterion("audit_opinion like", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionNotLike(String value) {
            addCriterion("audit_opinion not like", value, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionIn(List<String> values) {
            addCriterion("audit_opinion in", values, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionNotIn(List<String> values) {
            addCriterion("audit_opinion not in", values, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionBetween(String value1, String value2) {
            addCriterion("audit_opinion between", value1, value2, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andAuditOpinionNotBetween(String value1, String value2) {
            addCriterion("audit_opinion not between", value1, value2, "auditOpinion");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNull() {
            addCriterion("created_at is null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIsNotNull() {
            addCriterion("created_at is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedAtEqualTo(Date value) {
            addCriterion("created_at =", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotEqualTo(Date value) {
            addCriterion("created_at <>", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThan(Date value) {
            addCriterion("created_at >", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("created_at >=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThan(Date value) {
            addCriterion("created_at <", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtLessThanOrEqualTo(Date value) {
            addCriterion("created_at <=", value, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtIn(List<Date> values) {
            addCriterion("created_at in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotIn(List<Date> values) {
            addCriterion("created_at not in", values, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtBetween(Date value1, Date value2) {
            addCriterion("created_at between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedAtNotBetween(Date value1, Date value2) {
            addCriterion("created_at not between", value1, value2, "createdAt");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNull() {
            addCriterion("created_by is null");
            return (Criteria) this;
        }

        public Criteria andCreatedByIsNotNull() {
            addCriterion("created_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedByEqualTo(Long value) {
            addCriterion("created_by =", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotEqualTo(Long value) {
            addCriterion("created_by <>", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThan(Long value) {
            addCriterion("created_by >", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByGreaterThanOrEqualTo(Long value) {
            addCriterion("created_by >=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThan(Long value) {
            addCriterion("created_by <", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByLessThanOrEqualTo(Long value) {
            addCriterion("created_by <=", value, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByIn(List<Long> values) {
            addCriterion("created_by in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotIn(List<Long> values) {
            addCriterion("created_by not in", values, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByBetween(Long value1, Long value2) {
            addCriterion("created_by between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andCreatedByNotBetween(Long value1, Long value2) {
            addCriterion("created_by not between", value1, value2, "createdBy");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNull() {
            addCriterion("deleted_at is null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIsNotNull() {
            addCriterion("deleted_at is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedAtEqualTo(Date value) {
            addCriterion("deleted_at =", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotEqualTo(Date value) {
            addCriterion("deleted_at <>", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThan(Date value) {
            addCriterion("deleted_at >", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtGreaterThanOrEqualTo(Date value) {
            addCriterion("deleted_at >=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThan(Date value) {
            addCriterion("deleted_at <", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtLessThanOrEqualTo(Date value) {
            addCriterion("deleted_at <=", value, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtIn(List<Date> values) {
            addCriterion("deleted_at in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotIn(List<Date> values) {
            addCriterion("deleted_at not in", values, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtBetween(Date value1, Date value2) {
            addCriterion("deleted_at between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedAtNotBetween(Date value1, Date value2) {
            addCriterion("deleted_at not between", value1, value2, "deletedAt");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNull() {
            addCriterion("deleted_by is null");
            return (Criteria) this;
        }

        public Criteria andDeletedByIsNotNull() {
            addCriterion("deleted_by is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedByEqualTo(Long value) {
            addCriterion("deleted_by =", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotEqualTo(Long value) {
            addCriterion("deleted_by <>", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThan(Long value) {
            addCriterion("deleted_by >", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByGreaterThanOrEqualTo(Long value) {
            addCriterion("deleted_by >=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThan(Long value) {
            addCriterion("deleted_by <", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByLessThanOrEqualTo(Long value) {
            addCriterion("deleted_by <=", value, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByIn(List<Long> values) {
            addCriterion("deleted_by in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotIn(List<Long> values) {
            addCriterion("deleted_by not in", values, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByBetween(Long value1, Long value2) {
            addCriterion("deleted_by between", value1, value2, "deletedBy");
            return (Criteria) this;
        }

        public Criteria andDeletedByNotBetween(Long value1, Long value2) {
            addCriterion("deleted_by not between", value1, value2, "deletedBy");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}